#!/usr/local/bin/perl

#####################################################################################################
## diary@VOO.WHOpPERL version 2.00
##     Copyright (c) 2000-2004 by FAR/RAKUDA
##     All Rights Reserved
##     Last Modified at 2004.12.31
#####################################################################################################

#####################################################################################################
umask 000;
local($cginame) = 'diary';																			#	̃XNvg̖
local($cgiurl);																						#	̃XNvg̃AhX
local($cgiver) = '2.00';																			#	̃XNvg̃o[W
local($hit,$prev,$next,$last,@hit);
local($nowyear,$nowmonth,$nowday,$nowhour,$nowminute,$term,$nowweek);								#	݂̓ƁANbL[ێ
local($permission,$defalt_category);																#	݂̃[ŨANZX
local($charset,$laguage);
local($cookie_path);																				#	NbL[̔spX
local($ext);																						#	eLXgf[^̊gq
local($lock_file,$lock_type);																		#	t@C̃bN`
local($arc_permission,$dir_permission,$db_permission,$img_permission);								#	p[~bV̐ݒ
local($reject_cookie,$reject_location,$reject_modified);											#	httpwb_̐ݒ
local(%dir);																						#	et@Ci[fBNg
local(%url);																						#	eXNvg̃t@C
local(%script);																						#	t@C̕\AhX
local(%library);
local($javas_path,$smail_path);																		#	vÕpX
local(%text);																						#	eeLXgf[^̃t@C
local(%data);																						#	ef[^x[X̃t@C
local(%mime);																						#	mime_type̎
local(@shutout);																					#	ANZXۏ̃Xg
local(@nogood);																						#	͋֎~̃Xg
local(%admin);																						#	Ǘ
local($lines);																						#	\f[^
local($archive);																					#	őf[^ۑ
local(%cgi);																						#	̓f[^l
local(%cookie);																						#	̓NbL[
local(%access);																						#	ANZX
local($agent);																						#	NCAg
local(@content);																					#
local(@mode);																						#
local(@loop,%event);																				#
#####################################################################################################

#####################################################################################################
use Time::Local;																					#	Ԏ擾W[̓ǂݍ
use File::Copy;																						#	t@CRs[W[ǂݍ
require 'initial.cgi';																				#	ݒt@Ĉ݂
require qq|$dir{library}/$library{whopperl}|;														#	WHOpPERLTu[`Cu̓Ǎ
require	qq|$dir{library}/$library{miniboard}|;
#utime time(),time(),$script{$cginame} if($reject_modified);											#	݂̎XVƂďo
#####################################################################################################
	local(@fieldname) = 
	(
		'date',
		'filename_text',
		'filenumber'
	);
#####################################################################################################
&start;

	dbmopen(%DIARY,"$dir{database}/$data{diary}",undef);

	dbmopen(%WORD,"$dir{database}/$data{word}",undef);
	dbmopen(%SITE,"$dir{database}/$data{site}",undef);
	dbmopen(%FILE,"$dir{database}/$data{file}",undef);

	my(%exec)	=
	(
		'new'		=> 1,
		'detail'	=> 1,
		'correct'	=> 1,
		'post'		=> 1,
		'delete'	=> 1,
		'post_comments'		=> 1,
		'delete_comments'	=> 1,
		'correct_comments'	=> 1,
	);
&set_Main(%exec);
$object = 'main';
&execute;

	dbmclose(%FILE);
	dbmclose(%SITE);
	dbmclose(%WORD);

	dbmclose(%DIARY);

&finish;
#####################################################################################################
sub post_comments
{
	require qq|$dir{library}/comments_post.pl|;
	$cgi{cgi}		= $cginame;
	&Comments_post;

	$cgi{exec}		= 'detail';
	$cgi{date}	= $cgi{item};
	&detail;
}
sub delete_comments
{
	require qq|$dir{library}/comments_post.pl|;
	&Comments_delete;
}
sub correct_comments
{
	require qq|$dir{library}/comments.pl|;
	$cgi{date} = $cgi{item};
	&Comments_correct;
}
#####################################################################################################

#####################################################################################################
sub search
{
	$cgi{yearmonth}	= $cgi{yearmonth} eq '' ? qq|$nowyear/$nowmonth| : $cgi{yearmonth};
	my($nowdate) = sprintf("%04d/%02d/%02d",$nowyear,$nowmonth,$nowday);	#	
	my($word,$yearmonth) = ($cgi{word},$cgi{yearmonth});
	my(%field);

	my($where) = 	'<date> and (<date> lt $nowdate or $access{diary} & 0x140)'.
					($yearmonth ? qq| and <date> =~ m!^$yearmonth!| : '');

	my(@word) = split(' ',$word);
	my($where_word) = '1';
	foreach(@word)
	{
		$where_word .= qq| and "<text>" =~ m/\Q$_\E/|;
	}
	$where =~ s/<(.+?)>/\$field{$1}/g;
	$where_word =~ s/<(.+?)>/\$field{$1}/g;

	while(my($key,$value) = each %DIARY)
	{
		@field{@fieldname} = split(/\t/,$value);
		if(eval($where))
		{
			if($word)
			{
				open(TEXT,"$dir{text}/$field{filename_text}");
				$field{text} = join('',<TEXT>);
				close(TEXT);
			}
			if(eval($where_word)){push(@hit,$value);}
		}
	}

	$hit = @hit;
	$prev	= ($cgi{from} - $lines) < 0 ? 0 : ($cgi{from} - $lines);
	$next	= ($cgi{from} + $lines) > $hit ? $hit : ($cgi{from} + $lines);
	$last	= $hit - 1 - (($hit - 1) % $lines);

	@hit = (sort{$b cmp $a}@hit)[$cgi{from} .. $next - 1];
}
#####################################################################################################

#####################################################################################################
sub main
{
	&search;
	$Main = 'print_main';
}
#####################################################################################################

#####################################################################################################
sub new
{
	$who->push_error('݌܂B')		if(!$access{$cginame} & 0x140);

	$cgi{date}	= $cgi{date} || qq|$nowyear/$nowmonth/$nowday|;
	$Main		= $DIARY{$cgi{date}} ? 'print_correct' : 'print_new';
}
#####################################################################################################

#####################################################################################################
sub detail
{
	require qq|$dir{library}/comments.pl|;
	$who->push_error('ACew肳Ă܂B')	if(!$DIARY{$cgi{date}});
	$who->push_error('݌܂B')		if(!$access{news} & 0x140);
	$cgi{item} = $cgi{date};

	$Main = 'print_detail';
}
#####################################################################################################
sub correct	{&new;}
#####################################################################################################
sub post
{
	require	qq|$dir{library}/file_post.pl|;
	my(%field);

	#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
	$who->push_error('݌܂B')		unless($access{news} & 0x140);
	if($cgi{year} and $cgi{month} and $cgi{day})
	{
		$cgi{date} = sprintf("%04d/%02d/%02d",$cgi{year},$cgi{month},$cgi{day});
	}
	else
	{
		$who->push_error('tw肳Ă܂B');
	}

	$who->push_error('{͂Ă܂') unless($cgi{text});
	return if($who->error);
	#_______________________________________________________________________________________________#

	#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
	@field{@fieldname}	= split(/\t/,$DIARY{$cgi{date}}) if($DIARY{$cgi{date}});
	$cgi{filename_text}	= $field{filename_text} || sprintf("$data{$cginame}_%010d.$ext",time);
	$cgi{filenumber}	= &file_post($field{filenumber},$cgi{date},$cgi{category},$cookie{id});
	return if($who->error);
	#_______________________________________________________________________________________________#

	$who->lock;

	$DIARY{$cgi{date}} = join("\t",@cgi{@fieldname});

	#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
	open(TEXT,">$dir{text}/$cgi{filename_text}");
	print TEXT $cgi{text};
	close(TEXT);
	chmod($db_permission,"$dir{text}/$cgi{filename_text}");
	#_______________________________________________________________________________________________#

	my($delyear,$delmonth,$delday) = &get_date(time - 60 * 60 * 24 * $archive);				#	Ot@C̍폜Ώۓ
	my($deldate) = sprintf("%04d/%02d/%02d",$delyear,$delmonth,$delday);

	#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
	#<<<<<<<<<<	ÂO̍폜																		#
	dbmopen(%TITLE,"$dir{database}/$data{title}",undef);
	dbmopen(%CATEGORY,"$dir{database}/$data{category}",undef);										#	JeS[f[^x[XJ
	foreach(sort {$a cmp $b} keys %DIARY)
	{
		if($_ le $deldate)
		{
			@field{@fieldname} = split(/\t/,$DIARY{$_});
			next unless($field{date});
			my($year,$month,$day) = split("/",$_);
			open(LOG,">>$dir{archives}/$data{$cginame}_archive_$year$month.html");
			my($stdin) = select(LOG);
			print qq|<hr>\n|;
			&print_item($DIARY{$_});
			select($stdin);
			close(LOG);
			chmod($db_permission,"$dir{archives}/$data{$cginame}_archive_$year$month.html");
			delete($DIARY{$_});
			unlink("$dir{text}/$field{filename_text}") if(-f("$dir{text}/$field{filename_text}"));
		}
		else{	last;	}
	}
	dbmclose(%CATEGORY);
	dbmclose(%TITLE);
	#_______________________________________________________________________________________________#

	$who->unlock;

	$cgi{exec} = 'correct';
	$Main = 'print_correct';
} 
#####################################################################################################

#####################################################################################################
sub delete
{
	&delete_sub(\%DIARY,'date',$cgi{date});
}
#####################################################################################################



#####################################################################################################
sub print_main
{
	dbmopen(%COMMENTS,"$dir{database}/$data{comments}",undef);
	&SearchForm;

	print qq|<hr>\n|;

	if($hit)
	{
		&PageNavi($hit);

		print qq|<hr>\n|;
		&Contents($hit,$prev,$next,@hit);
		print qq|<hr>\n|;

		&PageNavi($hit);
	}
	else
	{
		print qq|<p class="notice">ɓĂ͂܂L͂܂łB</p>\n|;
	}
	dbmclose(%COMMENTS);
}
#####################################################################################################

#####################################################################################################
sub print_new
{
	&NewForm($cgi{date});
}
#####################################################################################################

#####################################################################################################
sub print_detail
{
	&Detail($DIARY{$cgi{date}});

	if($access{comments})
	{
		dbmopen(%COMMENTS,"$dir{database}/$data{comments}",undef);
		dbmopen(%PEAPLE,"$dir{database}/$data{peaple}",undef);
		dbmopen(%CHARACTER,"$dir{database}/$data{character}",undef);
		&Comments;
		dbmclose(%CARACTER);
		dbmclose(%PEAPLE);
		dbmclose(%COMMENTS);
	}
}
#####################################################################################################

#####################################################################################################
sub print_correct
{
	my($value) = $DIARY{$cgi{date}};
	&Detail($value);

	print qq|<hr>\n|;

	&DeleteForm('date',$cgi{date});

	print qq|<hr>\n|;

	&CorrectForm(split(/\t/,$value));
}
#####################################################################################################

#####################################################################################################
sub print_correct_comments
{
	my(%field,$comment);
	dbmopen(%COMMENTS,"$dir{database}/$data{comments}",undef);
	dbmopen(%PEAPLE,"$dir{database}/$data{peaple}",undef);
	dbmopen(%CHARACTER,"$dir{database}/$data{character}",undef);

	&Detail($DIARY{$cgi{date}});
	&CommentsCorrect;

	dbmclose(%CARACTER);
	dbmclose(%PEAPLE);
	dbmclose(%COMMENTS);
}
#####################################################################################################



#####################################################################################################
sub get_link
{
	my($enc) = &WHOpPERL::encode($cgi{word});
	return(qq|&amp;word=$enc{word}&amp;yearmonth=$cgi{yearmonth}|);
}
sub get_link_comments
{
	return(qq|exec=detail&amp;date=$cgi{item}&amp;|);
}
sub MainMenu_submenu
{
	if($access{$cginame} & 0x140)
	{
		print qq|<ul class="submenu">\n|;
		print qq|<li><a href="$cgiurl?exec=new">|.&title("$cginame\_new").qq|</a></li>\n|;
		print qq|</ul>\n|;
	}
}
#####################################################################################################



#####################################################################################################
sub Contents_head
{
	my($from)	= $cgi{from} + 1;
	my($year,$month) = split(/\//,$cgi{yearmonth});
	print qq|<h3><a href="#Contents">|.($year ? "$yearN".($month ? "$month" : '') : 'S').qq|</a></h3>\n|;
	printf(qq|<h4>No.%02d - No.%02d / %02d hits</h4>\n|,$from,$next,$hit);
}
#####################################################################################################

#####################################################################################################
sub SearchForm_sub
{
	my($i,$j);
	my($startyear,$startmonth) = &get_date(time - 60 * 60 * 24 * $archive);				#	Ot@C̍폜Ώۓ
	my($endmonth) = 12;
	print		qq|<div class="date">\n|.
				qq|<label for="SearchDate">t</label>\n|.
				qq|<select id="SearchDate" name="yearmonth">\n|.
				qq|<option value="0">ׂ</option>\n|;
	for($i = $startyear;$i <= $nowyear;$i++)
	{
		my($year) = sprintf("%04d",$i);
		print	qq|<option |.($cgi{yearmonth} eq qq|$year| ? qq|selected="selected" | : '').qq|value="$year">$yearN</option>\n|;
#		print 	qq|<optgroup label="$yearN">\n|;
		$endmonth = $nowmonth if($year eq $nowyear);
		for($j = $startmonth;$j <= $endmonth;$j++)
		{
			my($month) = sprintf("%02d",$j);
			print	qq|<option |.($cgi{yearmonth} eq qq|$year/$month| ? qq|selected="selected" | : '').
					qq|value="$year/$month">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$month</option>\n|;
		}
#		print	qq|</optgroup>\n|;
		$startmonth = 1;
	}
	print		qq|</select>\n|.
				qq|</div><!--date-->\n|;

	&SearchFormWord;

	&SearchFormExec;
}
#####################################################################################################

#####################################################################################################
sub print_item
{
	my(%field);
	@field{@fieldname}				= split(/\t/,$_[0]);
	@field{'year','month','day'}	= split("\/",$field{date});
	print		qq|<div id="Item$field{year}$field{month}$field{day}" class="item">\n|;
	print		qq|<h5 class="subject date">|;
	print		qq|<a href="#Item$field{year}$field{month}$field{day}">|;
	printf("%4sN%2s%2s",$field{year},$field{month},$field{day});
	print		qq|</a>|;
	print		qq|</h5>\n|;
	print		qq|<div class="content">\n|;
	print		&print_text(&get_text($field{filename_text}));
	&print_file($field{filenumber})	if($field{filenumber});
	print		qq|</div><!--content-->\n|;
	if($cgi{exec} ne 'correct' and $cgi{exec} ne 'post' and ($access{diary} & 0x140 or $access{comments}))
	{
		print	qq|<div class="exec">\n|;
		@field{'cgi','item','thread','comment'} = split(/\t/,$COMMENTS{"$cginame\_$field{date}"});
		$field{comment}+=0;
		print	qq|<a href="$script{$cginame}?exec=detail&amp;date=$field{date}">|.
					&title("$cginame\_Comments").qq|($field{comment})</a>\n|		 if($access{comments} and $cgi{exec} ne 'detail');
		print	qq|<a href="$script{diary}?exec=correct&amp;date=$field{date}" title="|.
				&title("$cginame\_item").&title('corrct').qq|:$field{date}">|.&title('correct').qq|</a>\n|;
		print	qq|</div>\n|;
	}
	print		qq|</div><!--item-->\n|;
}
#####################################################################################################

#####################################################################################################
sub print_post
{
	my(%field);
	@field{'date','text','file'} = @_;
	@field{'year','month','day'} = split("\/",$field{date});
	print		qq|<form id="postform" name="postform" method="post" enctype="multipart/form-data" action="$cgiurl">\n|;
	print		qq|<div class="form">\n|;
	print		qq|<fieldset class="date">\n|.
				qq|<legend ondblclick="helppage('#diary_post_date');">t</legend>\n|;
	print		qq|<label>|.
				qq|<select name="year">\n|;
	for($i = $nowyear-5;$i <= $nowyear;$i++)
	{
		print	qq|<option value="$i"|.($field{year} == $i ? qq| selected="selected"| : '').qq|>$i</option>\n|;
	}
	print		qq|</select>N\n|.
				qq|</label>\n|;
	print		qq|<label>\n|.
				qq|<select name="month">\n|;
	for($i = 1;$i <= 12;$i++)
	{
		print	qq|<option value="$i"|.($field{month} == $i ? qq| selected="selected"| : '').qq|>$i</option>\n|;
	}
	print		qq|</select>\n|.
				qq|</label>\n|;
	print		qq|<label>\n|.
				qq|<select name="day" id="Pd">\n|;
	for($i = 1;$i <= 31;$i++)
	{
		print	qq|<option value="$i"|.($field{day} == $i ? qq| selected="selected"| : '').qq|>$i</option>\n|;
	}
	print		qq|</select>\n|.
				qq|</label>\n|;
	print		qq|</fieldset>\n|;

	&PostFormText(&get_text($field{text}));
	&PostFormFile() if($cookie{id});

	print		qq|<div class="exec">\n|.
				qq|<input type="hidden" name="exec" value="post">\n|.
				qq|<input type="submit" value="|.&title("$cginame\_submit").qq|">\n|;
				qq|</div>\n|;
	print		qq|</div>\n|;
	print		qq|</form>\n|;
}
#####################################################################################################
1;
