#####################################################################################################
	@fieldname = 
	(
		'begin',
		'finish',
		'bweek',
		'fweek',
		'btime',
		'ftime',
		'eventtype',
		'key',
		'event',
		'category',
		'filename_text',
		'filenumber',
		'page',
		'site',
		'userid',
		'group',
		'mode'
	);
#####################################################################################################
sub search
{
	my($EVENT,$SUB) = @_;
	my($word,$category,$mode,$year,$month,$day) = ($cgi{word},$cgi{category},$cgi{mode},$cgi{year},$cgi{month},$cgi{day});
	my(%field);
	my($subject,@subject);

	my($date,$week,$max_day);

	if($year and $month and $day)
	{
		$max_day = &max_day($year,$month);
		$day = ($day > $max_day) ? $max_day : $day;
		$week = ('','','','','','','y')[(localtime(&timelocal(0,0,0,$day,$month - 1,$year)))[6]];
	}
	$day	= sprintf("%02d",$day)		if($day);
	$month	= sprintf("%02d",$month)	if($month);
	$date	= qq|$year/$month/$day|;

	my($where) = 	'<event>'.
					($mode ? qq| and <category> eq '$category'| : $category != 0 ? qq| and <category> =~ m/^$category/| : '').
					($day ? qq| and (<loop> < 2 or 6 < <loop>|.
						 	qq| or (<loop> == 2 and <bweek> eq '$week')|.
						 	qq| or (<loop> == 3 and (	(<bday> le '$day' and '$day' le <fday>) or
														('$day' le <fday> and <fday> lt <bday>) or
														(<fday> lt <bday> and <bday> le '$day')
													))|.
						 	qq| or (<loop> == 4 and (	("<bmonth>/<bday>" le '$month/$day' and '$month/$day' le "<fmonth>/<fday>") or
														('$month/$day' le "<fmonth>/<fday>" and "<fmonth>/<fday>" lt "<bmonth>/<bday>") or
														("<fmonth>/<fday>" lt "<bmonth>/<bday>" and  "<bmonth>/<bday>" le '$month/$day')
													))|.
						 	qq| or (<loop> == 5 and '$week' ne "")|.
							qq| or (<loop> == 6 and '$week' ne "" and '$week' ne "y"))|.
							qq| and <begin> le '$date' and '$date' le <finish>| : 
						($month ?	qq| and (<loop> != 4|.
									qq| or (	("<bmonth>" le '$month' and '$month' le "<fmonth>") or
												('$month' le "<fmonth>" and "<fmonth>" lt "<bmonth>") or
												("<fmonth>" lt "<bmonth>" and  "<bmonth>" le '$month')))|.
									qq| and "<byear>/<bmonth>" le '$year/$month' and '$year/$month' le "<fyear>/<fmonth>"| :
					  		$year ? qq| and <byear> le '$year' and '$year' le <fyear>| : ''));

	my(@word) = split(' ',$word);
	foreach(@word)
	{
		$where .= qq| and "<text><event><site><more>" =~ m/\Q$_\E/|;
	}
	$where =~ s/<([^<>]+?)>/\$field{$1}/g;

	while(my($key,$value) = each %{$EVENT})
	{
		undef($subject);
		@field{@fieldname}	= split(/\t/,$value);
		$field{loop}		= $event{$field{eventtype}} + $field{eventtype};
		if($SUB and
		(
			($field{finish} and $field{finish} lt $weekdate and $field{loop} < 7)	#	ITԑÔŊtłȂƂ
			or
			($field{begin} lt $weekdate and $field{loop} == 7)						#	JnTԑÔňTԊ̂Ƃ
			or
			($field{begin} lt $lastdate and $field{loop} == 8)						#	JnꃖÔňꃖ̂Ƃ
			or
			($field{begin} lt $yeardate and $field{loop} == 9)						#	JnNÔňN̂Ƃ
		))
		{
			$SUB->{$field{key}} = $EVENT->{$field{key}};
			delete($EVENT->{$field{key}});
			next;
		}
		@field{'byear','bmonth','bday'} = split("\/",$field{begin});
		@field{'fyear','fmonth','fday'} = split("\/",$field{finish});
		if($word)
		{
			undef($field{more});
			@subject = split(' ',$field{event});
			foreach(@subject)
			{
				$subject .= $_;
				$field{more} .= qq|$WORD{$_}$WORD{$subject}|;
				$subject .= ' ';
			}
			open(TEXT,"$dir{text}/$field{text}");
			$field{text} = join('',<TEXT>);
			close(TEXT);
		}
		if(eval($where)){push(@hit,$value);}
	}
	#_______________________________________________________________________________________________#

	$hit = @hit;
	$prev	= ($cgi{from} - $lines) < 0 ? 0 : ($cgi{from} - $lines);
	$next	= ($cgi{from} + $lines) > $hit ? $hit : ($cgi{from} + $lines);
	$last	= $hit - 1 - (($hit - 1) % $lines);

	@hit = (sort{$b cmp $a}@hit)[$cgi{from} .. $next - 1];
}
#####################################################################################################

#####################################################################################################
sub print_item_date
{
	my(%field);
	my($begin,$finish,$bweek,$fweek,$btime,$ftime,$loop) = @_;
	my($byear,$bmonth,$bday) = split("\/",$begin);
	my($fyear,$fmonth,$fday) = split("\/",$finish);
	print $byear;
	print qq|/$bmonth|			if($loop != 4);
	print qq|/$bday|			if($loop != 3 and $loop != 4);
	print qq|($bweek)|			if($loop < 2);
	print $btime				if($btime ne '==:==' and $loop == 0);
	if($begin ne $finish or ($btime ne $ftime and $loop == 0))
	{
		print ' - '				if(($byear ne $fyear) or ($bmonth ne $fmonth and $loop < 4) or ($begin ne $finish and ($loop != 4)) or ($btime ne $ftime and $loop == 0));
		if($fyear ne '====' or $fmonth ne '==' or $fday ne '==')
		{
			if($fyear ne '====' or $fmonth ne '==' or $loop != 3)
			{
				print $fyear	if( $byear ne $fyear and ($fyear ne '====' or $loop != 4));
				print qq|/|		if( $byear ne $fyear and $loop != 4);
				print $fmonth	if(($byear ne $fyear or $bmonth ne $fmonth) and $loop != 4);
			}
			print qq|/|			if(($byear ne $fyear or $bmonth ne $fmonth) and ($loop != 3 and $loop != 4));
			print $fday			if(($begin ne $finish) and ($loop != 3 and $loop != 4));
			print qq|($fweek)|	if( $begin ne $finish and $loop < 2);
			print $ftime		if($btime ne $ftime and $loop == 0);
		}
	}
}
#####################################################################################################

#####################################################################################################
sub print_item_loop
{
	my($begin,$finish,$bweek,$fweek,$btime,$ftime,$loop) = @_;
	my($byear,$bmonth,$bday) = split("\/",$begin);
	my($fyear,$fmonth,$fday) = split("\/",$finish);
	print qq|$loop[$loop] |;
	print qq|($bweek)|	if($loop == 2);
	print qq|$bmonth/|	if($loop == 4);
	print $bday			if($loop == 3 or $loop == 4);
	print ' - '			if(($bmonth ne $fmonth and $loop == 4) or ($bday ne $fday and ($loop == 3 or $loop == 4)));
	print qq|$fmonth/|	if( $bmonth ne $fmonth and $loop == 4);
	print $fday			if(($bmonth ne $fmonth and $loop == 4) or ($bday ne $fday and ($loop == 3 or $loop == 4)));
}
#####################################################################################################

#####################################################################################################
sub print_item_time
{
	my($btime,$ftime) = @_;
	print $btime					if($btime ne '==:==');
	print qq| - $ftime|			if($btime ne $ftime);
}
#####################################################################################################
1;
