
#####################################################################################################
sub RelationSchedules
{
	&RelationEvents('schedule','Schedules',@_);
}
#####################################################################################################

#####################################################################################################
sub RelationHistories
{
	&RelationEvents('history','Histories',@_);
}
#####################################################################################################

#####################################################################################################
sub RelationEvents
{
	my($cginame,$id,$EVENT,$hit) = @_;
	while(($key,$value) = each(%{$EVENT}))
	{
		push(@event,$value) if($value =~ /\s\Q$hit/);
	}
	if(@event)
	{
		print qq|<hr>\n|;
		print qq|<table id="Relation$id" class="$cginame index list" frame="border" border="1">\n|;
		print qq|<caption><a href="#Relation$id">|.&title('Relation').&title("$cginame\_item").qq|</a></caption>\n|;
		&Index_head_event;
		foreach(sort {$b cmp $a} @event)
		{
			&print_each_event($_,$cginame);
		}
		print qq|</table>\n|;
	}
}
#####################################################################################################

#####################################################################################################
sub Index_head_event
{
	print qq|<tr>\n|;
	print qq|<th colspan="4" class="date"></th>\n|;
	print qq|<th class="subject" rowspan="2">e</th>\n|;
	print qq|<th class="address" rowspan="2">ꏊ</th>\n|;
	print qq|</tr>\n|;
	print qq|<tr>\n|;
	print qq|<th class="date"></th>\n|;
	print qq|<th class="date">J</th>\n|;
	print qq|<th class="date"></th>\n|;
	print qq|<th class="date"></th>\n|;
	print qq|</tr>\n|;
}
#####################################################################################################

#####################################################################################################
sub print_each_event
{
	my($hit,$cginame) = @_;
	my(%field,$loop);
	@field{'begin','finish','bweek','fweek','btime','ftime','loop','key','event','category','text','file','page','site'} = split(/\t/,$hit);
	@field{'byear','bmonth','bday'} = split("\/",$field{begin});
	@field{'fyear','fmonth','fday'} = split("\/",$field{finish});
	$loop = $event{$field{loop}} + $field{loop};

	print qq|<tr>\n|;
	#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
	#<<<<<<<<<<																					#
	if($old{begin} ne $field{begin} or $old{finish} ne $field{finish} or $old{btime} ne $field{btime} or $old{ftime} ne $field{ftime} or $old{loop} ne $field{loop})
	{
		print qq|<td class="date">\n|;
		print ((                      $old{byear} ne $field{byear}) ? $field{byear} : '    ');
		print ((                      $old{byear} ne $field{byear} and $loop != 4) ? qq|/| : ' ');
		print ((($oldloop != $loop or $old{byear} ne $field{byear} or $old{bmonth} ne $field{bmonth}) and $loop != 4)? $field{bmonth} : '  ');
		print ((($oldloop != $loop or $old{byear} ne $field{byear} or $old{bmonth} ne $field{bmonth}) and ($loop != 3 and $loop != 4)) ? qq|/| : ' ');
		print ((($oldloop != $loop or $old{byear} ne $field{byear} or $old{bmonth} ne $field{bmonth} or $old{bday} ne $field{bday}) and ($loop != 3 and $loop != 4)) ? $field{bday} : '  ');
		print ((($oldloop != $loop or $old{begin} ne $field{begin}) and $loop < 2) ? qq|($field{bweek})| : "    ");
		print (($field{btime} ne '==:==' and $loop == 0) ? $field{btime} : '     ');
		if($field{begin} ne $field{finish} or ($field{btime} ne $field{ftime} and $loop == 0))
		{
			print ((($field{byear} ne $field{fyear}) or ($field{bmonth} ne $field{fmonth} and $loop < 4) or ($field{begin} ne $field{finish} and ($loop != 4)) or ($field{btime} ne $field{ftime} and $loop == 0)) ? '-' : ' ');
			print ( ($field{byear} ne $field{fyear}) ? $field{fyear} : '    ');
			print ( ($field{byear} ne $field{fyear} and $loop != 4) ? qq|/| : ' ');
			print ((($field{byear} ne $field{fyear} or $field{bmonth} ne $field{fmonth}) and $loop != 4) ? $field{fmonth} : '  ');
			print ((($field{byear} ne $field{fyear} or $field{bmonth} ne $field{fmonth}) and ($loop != 3 and $loop != 4)) ? qq|/| : ' ');
			print ((($field{begin} ne $field{finish}) and ($loop != 3 and $loop != 4)) ? $field{fday} : '  ');
			print ( ($field{begin} ne $field{finish} and $loop < 2) ? qq|($field{fweek})| : "    ");
			print (($field{btime} ne $field{ftime} and $loop == 0) ? $field{ftime} : '     ');
		}
		else
		{
			print qq|                |;
		}
		print qq|</td>\n|;
		print qq|<td class="date">\n|;
		if($old{begin} ne $field{begin} or $old{finish} ne $field{finish} or $old{loop} ne $field{loop})
		{
			print (($event{$field{loop}} ne '') ? qq|$field{loop}| : $loop[$loop]);
		}
		print qq|</td>\n|;
		print qq|<td class="date">\n|;
		if($loop == 2)
		{
			print qq|($field{bweek})|;
		}
		else
		{
			print (($loop == 4) ? qq|$field{bmonth}/| : '   ');
			print (($loop == 3 or $loop == 4) ? $field{bday} : '  ');
			print ((($field{bmonth} ne $field{fmonth} and $loop == 4) or ($field{bday} ne $field{fday} and ($loop == 3 or $loop == 4))) ? '-' : '  ');
			print ( ($field{bmonth} ne $field{fmonth} and $loop == 4) ? qq|$field{fmonth}/| : '   ');
			print ((($field{bmonth} ne $field{fmonth} and $loop == 4) or ($field{bday} ne $field{fday} and ($loop == 3 or $loop == 4))) ? $field{fday} : '  ');
		}
		print qq|</td>\n|;
		print qq|<td class="date">\n|;
		if($loop != 0)
		{
			print $field{btime}					if($field{btime} ne '==:==');
			print qq|-$field{ftime}|			if($field{btime} ne $field{ftime});
		}
		print qq|</td>\n|;
	}
	else	{	print qq|<td class="date" colspan="4"></td>\n|;	}
	#_______________________________________________________________________________________________#

	#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
	#<<<<<<<<<<	Cxg																			#
	print qq|<td class="subject">\n|;
	print qq|<a href="$script{$cginame}?exec=detail&amp;key=$field{key}" title="|.
			&title("$cginame\_item").qq|:$field{event}($CATEGORY{$field{category}})">|;
	&print_category_icon($field{category},'[E]');
	print qq|$field{event}|;
	print qq|</a>\n|;
	&print_reference_link($field{page});
	print qq|</td>\n|;
	#_______________________________________________________________________________________________#

	#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
	#<<<<<<<<<<	ꏊ																				#
	print qq|<td class="address">\n|;
	if($field{site})
	{
		@field{'xx','xx','xx','xx','url'} = split(/\t/,$SITE{$field{site}});
		if($field{url})	{	print qq|<a href="$field{url}" title="|.&title('site_item').qq|:$field{site}">$field{site}</a>|;	}
		else			{	print qq|$field{site}\n|;							}
	}
	print qq|</td>\n|;
	#_______________________________________________________________________________________________#

	print qq|</tr>\n|;
	%old = %field;
	$oldloop = $loop;
}
#####################################################################################################
1;
