package main;
	require	qq|$dir{library}/word_relation.pl|;
	my(%exec)	=
	(
		'new'		=> 1,
		'detail'	=> 1,
		'correct'	=> 1,
		'dictionary'=> 1,
		'post'		=> 1,
		'delete'	=> 1
	);
&set_Main(%exec);
#####################################################################################################
sub main
{
	&search;
	@hit = (sort{$a cmp $b}@hit)[$cgi{from} .. $next - 1];
	$Main = 'print_main';
}
#####################################################################################################

#####################################################################################################
sub new
{
	$who->push_error('܂B')					if(!$access{$cginame} & 0x155);
	$Main = 'print_new';
}
#####################################################################################################

#####################################################################################################
sub detail
{
	require	qq|$dir{library}/site_relation.pl|;
	require	qq|$dir{library}/event_relation.pl|;
	$who->push_error('̒P͓o^Ă܂B')			if(!$WORD{$cgi{word}});

	$Main = 'print_detail';
}
#####################################################################################################

#####################################################################################################
sub correct
{
	$who->push_error('܂B')					if(!$access{$cginame} & 0x155);

	$Main = 'print_correct';
}
#####################################################################################################

#####################################################################################################
sub post
{
	require	qq|$dir{library}/file_post.pl|;
	my(%field);
	dbmopen(%FILE,"$dir{database}/$data{file}",undef);

	#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
	$who->push_error('݌܂B')			unless($access{word} & 0x155);
	$who->push_error('̒P͊ɓo^Ă܂B')	if($WORD{$cgi{word}} and $cgi{old} ne $cgi{word});
	$who->push_error('Pꂪ͂Ă܂B')			unless($cgi{word});
	$who->push_error('ǂ݂͂Ă܂B')			unless($cgi{sound});
	$who->push_error('Ӗ͂Ă܂B')			unless($cgi{mean});
	$who->push_error('f[^TCY傫܂BӖǂ݂ZĂB')	if(length(join("\t",@cgi{@fieldname})) > 512);
	return if($who->error);
	#_______________________________________________________________________________________________#

	#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
	@field{@fieldname}	= split(/\t/,$WORD{$cgi{old}}) if($cgi{old});

	$cgi{filename_text}	= $field{filename_text} || sprintf("$data{$cginame}_%010d.$ext",time);
	$cgi{imesound}		= $cgi{imesound} || $cgi{sound};
	$cgi{userid}		= $cookie{id} || $cookie{name} || $field{userid};

	$cgi{filenumber}	= &file_post($field{filenumber},$cgi{word},$cgi{category},$cgi{userid});
	return if($who->error);
	#_______________________________________________________________________________________________#

	$who->lock;

	delete($WORD{$cgi{old}});
	$WORD{$cgi{word}} = join("\t",@cgi{@fieldname});

	#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
	&save_text($cgi{filename_text},$cgi{text});
	#_______________________________________________________________________________________________#

	$who->unlock;

	dbmclose(%FILE);

	#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
	$cgi{exec} = 'correct';
	&correct;
	#_______________________________________________________________________________________________#
}
#####################################################################################################

#####################################################################################################
#----------	ef[^̍폜																		#
sub delete
{
	&delete_sub(\%WORD,'word',$cgi{word});
}
#####################################################################################################



#####################################################################################################
sub print_main
{
	&SpelNavi;
	print qq|<hr>\n|;
	&SearchForm;
	print qq|<hr>\n|;

	if($hit)
	{
		&PageNavi($hit);
		print qq|<hr>|;

		&Index($hit,$prev,$next,@hit);

		print qq|<hr>|;
		&PageNavi($hit);
	}
	else
	{
		print qq|<p class="notice">ɓĂ͂܂錟ʂ܂łB</p>\n|;
	}
}
#####################################################################################################

#####################################################################################################
sub print_new
{
	&NewForm("",$cgi{word});
}
#####################################################################################################

#####################################################################################################
sub print_detail
{
	my($key,$value);
	my(%field,@subject,$subject);

	my(@field) = split(/\t/,$WORD{$cgi{word}});

	&Detail(@field);

	#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
	#<<<<<<<<<<	֘A																			#
	&RelationWords($field[6],qq|$field[1]xxx|)	if($access{word});
	#_______________________________________________________________________________________________#

	#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
	#<<<<<<<<<<	֘ATCg̕\																	#
	&RelationSites(@field[1])					if($access{site});
	#_______________________________________________________________________________________________#

	if($access{schedule})
	{
		dbmopen(%SCHEDULE,"$dir{database}/$data{schedule}",undef);
		&RelationSchedules(\%SCHEDULE,$field[1]);
		dbmclose(%SCHEDULE);
	}

	if($access{history})
	{
		dbmopen(%HISTORY,"$dir{database}/$data{history}",undef);
		&RelationHistories(\%HISTORY,$field[1]);
		dbmclose(%HISTORY);
	}
}
#####################################################################################################

#####################################################################################################
sub print_correct
{
	my(@field);
	@field = split(/\t/,$WORD{$cgi{word}});
	&Detail(@field);
	print qq|<hr>\n|;
	&DeleteForm('word',$cgi{word});
	print qq|<hr>\n|;
	&CorrectForm(@field);
}
#####################################################################################################



#####################################################################################################
sub get_link
{
	my($word)	= &WHOpPERL::encode($cgi{word});
	my($sound)	= &WHOpPERL::encode($cgi{sound});
	return(qq|&amp;exec=search&amp;word=$word&amp;category=$cgi{category}&amp;part=$cgi{part}&amp;sound=$sound&amp;mode=$cgi{mode}|);
}
sub MainMenu_submenu
{
	if($access{$cginame} & 0x155)
	{
		print qq|<ul class="submenu">\n|;
		print qq|<li><a href="$cgiurl?exec=new">|.&title("$cginame\_new").qq|</a></li>\n|;
		print qq|</ul>\n|;
	}
}
#####################################################################################################



#####################################################################################################
sub SpelNavi
{
	my($i,$sound,$soundcgi);
	print qq|<fieldset id="SpelNavi" class="navigation">\n|;
	print qq|<legend><a href="#SpelNavi">SpelNavi</a></legend>\n|;
	print qq|<ul class="link">\n|;
	print qq|<li>\n|;
	for($i = 0xA0;$i <= 0xF1;++$i)
	{
		$sound = chr(0x82).chr($i);
		next unless($sound =~ /(|||||||||||||||||||||||||||||||||||||||||||||)/);
		$soundcgi = qq|\%82\%|.sprintf("%02X",$i);
		if($cgi{sound} eq $sound)
		{
			print qq|<a>$sound</a>\n|;
		}
		else
		{
			print qq|<a href="$script{word}?exec=search&amp;category=$cgi{category}&amp;sound=$soundcgi" title="u$soundv̌">$sound</a>\n|;
		}
		print qq|<a>@</a>\n| if($sound =~ /(|)/);
		print qq|<a>@</a>\n<a>@</a>\n<a>@</a>\n| if($sound =~ /()/);
		print qq|<a>@</a>\n<a>@</a>\n<a>@</a>\n<a>@</a>\n| if($sound =~ /()/);
		print qq|</li>\n<li>\n| if($sound =~ /(|||||||||)/);
	}
	print qq|</li>\n|;
	print qq|</ul>\n|;
	print qq|</fieldset>\n|;
}
#####################################################################################################

#####################################################################################################
sub SearchForm_sub
{
	my($i);
	&SearchFormCategory;

	print	qq|<div class="category">\n|.
			qq|<label for="SearchPart" ondblclick="helppage('#word_search_part');" title="W click to help">i</label>\n|.
			qq|<select id="SearchPart" name="part">\n|.
			qq|<option value="">ׂ</option>\n|;
	for($i = 0;$i < 28;$i++)
	{
		print qq|<option value="$i"|.($cgi{part} eq $i ? qq| selected="selected"|:'').qq|>|;printf(qq|%-16s/%16s</option>\n|,$ime[$i],$atok[$i]);
	}
	print	qq|</select>\n|.
			qq|</div>\n|;
	print	qq|<div class="word">\n|.
			qq|<label for="SearchSound" ondblclick="helppage('#word_search_sound');" title="W click to help"></label>\n|.
			qq|<input id="SearchSound" name="sound" type="text" value="$cgi{sound}" size="2" maxlength="2">\n|.
			qq|</div>\n|;

	&SearchFormWord;

	print	qq|<div class="exec" ondblclick="helppage('#word_search');" title="W click to help">\n|.
			qq|<button name="exec" type="submit" value="search"></button>\n|.
			qq|</div>\n|;
	print	qq|<fieldset class="more">\n|.
			qq|<legend ondblclick="helppage('#word_search_ime');" title="W click to help">`</legend>\n|.
			qq|<label><input name="ime" type="radio" value="ime" checked="checked">MS-IME</label>\n|.
			qq|<label><input name="ime" type="radio" value="atok">atok 14</label>\n|.
			qq|</fieldset>\n|;
	print	qq|<div class="exec" ondblclick="helppage('#word_ime');" title="W click to help">\n|.
			qq|<button name="exec" type="submit" value="dictionary">o</button>\n|.
			qq|</div>\n|;
}
#####################################################################################################

#####################################################################################################
sub Index_head
{
	&Index_head_word;
}
#####################################################################################################

#####################################################################################################
sub print_each
{
	&print_each_word;
}
#####################################################################################################

#####################################################################################################
sub print_item
{
	dbmopen(%FILE,"$dir{database}/$data{file}",undef);
	my(%field,%enc);
	@field{@fieldname} = @_;
	$enc{word} = &WHOpPERL::encode($field{word});

	print qq|<div id="WordItem" class="item">\n|;
	print qq|<div class="subject">\n|;
	print qq|<a href="#WordItem">|;
	&print_category_icon($field{category},'[W]');
	&print_subject_word(@_);
	print qq|</a>\n|;
	&print_reference_link($field{page});
	print qq|<span class="category">\n|;
	print qq|$ime[$field{part}]\n|;
	print qq|</span>\n|;
	print qq|</div><!--subject-->\n|;

	print qq|<div class="content">\n|;
	print qq|<div class="comment">\n|;
	print qq|$field{mean}\n|;
	print qq|</div>\n|;
	print &print_text(&get_text($field{filename_text}));
	&print_file($field{filenumber})	if($field{filenumber});
	print qq|</div><!--content-->\n|;

	print qq|<div class="exec">\n|;
	if($cgi{exec} ne 'correct' and ($access{word} & 0x155))
	{
		print qq|<a href="$script{word}?exec=correct&word=$enc{word}">|.&title('correct').qq|</a>\n|;
	}
	print qq|</div>\n|;
	print qq|</div><!--item-->\n|;

	dbmclose(%FILE);
}
#####################################################################################################

#####################################################################################################
sub print_post
{
	my(%field,$i);
	@field{'sound','word','category','text','file','mean','more','part','page','imesound'} = @_;
	print	qq|<form method="post" enctype="multipart/form-data" action="$script{word}" name="postform">\n|;
	print	qq|<div class="form">\n|;
	&print_input_text('post','subject','word',$field{word},'o^P',60);
	&print_input_text('post','name','sound',$field{sound},'݂',80);
	&print_input_text('post','more','imesound',$field{imesound},'ϊ',80);
	&PostFormCategory($field{category});
	print	qq|<div class="category">\n|.
			qq|<label for="PostPart" ondblclick="helppage('#word_post_part');" title="W click to help">i</label>\n|.
			qq|<select id="PostPart" name="part">\n|;
	for($i=0;$i<28;$i++)
	{
		my($part) = sprintf(qq|%-16s/%16s\n|,$ime[$i],$atok[$i]);
		$part =~ s/ /&nbsp;/g;
		print qq|<option value="$i"|.($field{part} eq $i ? qq| selected="selected"| : '').qq|>$part</option>|;
	}
	print	qq|</select></label>\n|.
			qq|</div>\n|;
	&print_input_text('post','comment','mean',$field{mean},'Ӗ',90);
	&print_input_text('post','more','more',$field{more},'֘AP',80);
	#_______________________________________________________________________________________________#

	#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
	&PostFormText(&get_text($field{text}));
	&PostFormFile();
	#_______________________________________________________________________________________________#

	#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
	#<<<<<<<<<<	y[W																				#
	&print_input_text('post','address','page',$field{page},'y[W',80);
	#_______________________________________________________________________________________________#

	#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
	#<<<<<<<<<<	o^{^																			#
	print	qq|<div class="exec">\n|;
	print	qq|<label><input type="checkbox" name="old" value="$field{word}" checked="checked">㏑</label>\n| if($field{word});
	print	qq|<input type="hidden" name="exec" value="post">\n|.
			qq|<input type="submit" value="|.&title("$cginame\_submit").qq|">\n|.
			qq|</div>\n|;
	#_______________________________________________________________________________________________#
	print qq|</div>\n|;
	print qq|</form>\n|;
}
#####################################################################################################

#####################################################################################################
sub dictionary
{
	my(%field);
	my($ret) = qq|\x0D|.($ENV{HTTP_USER_AGENT} =~ /Windows/i ? qq|\x0A| : '');

	print qq|Content-type: text/dictionary; charset=Shift_JIS\n\n|;
	binmode STDOUT;
	if($cgi{ime} eq 'atok')	{	print qq|!!DICUT14$ret$ret|;	}
	else					{	print qq|!Microsoft IME Dictionary Tool 98$ret!Version:$ret!Format:WORDLIST$ret$ret|;	}

	&search;	#
	@hit = sort{$a cmp $b}@hit;

	foreach(@hit)
	{
		@field{@fieldname} = split(/\t/,$_);
		@sound = split(/,/,$field{imesound});								#" "œǂݕ؂
		foreach(@sound)
		{
			print qq|$_\t$field{word}\t|.(($cgi{ime} eq 'atok') ? $atok[$field{part}] : $ime[$field{part}]).qq|\t$field{mean}$ret|;
		}
	}
}
#####################################################################################################
return('main');
