$Option = 'print_option'				if($access{today} or $access{calender} or $access{schedule});
$Introduction = 'print_introduction'	if($access{news} or $access{graffiti} or $access{forum} or $access{message});

#####################################################################################################
sub print_option
{
	local(%old);
	my(%field);
	my(@future,@today,@present,@lately,@subject);
	my($nowdate)	= sprintf("%04d/%02d/%02d",$nowyear,$nowmonth,$nowday);		#	
	my($headdate)	= sprintf("%04d/%02d/%02d",&get_date(time-3*24*60*60));		#	T̂܁i3Oj
	my($hipdate)	= sprintf("%04d/%02d/%02d",&get_date(time+3*24*60*60));		#	T̂i3j
	my($weekdate)	= sprintf("%04d/%02d/%02d",&get_date(time-7*24*60*60));		#	1TԑO
	my($nextdate)	= sprintf("%04d/%02d/%02d",&get_date(time+30*24*60*60));	#	1
	my($lastdate)	= sprintf("%04d/%02d/%02d",&get_date(time-30*24*60*60));	#	1O
	#-------------------------------------------------------------------------------------------#
	#	Cxgf[^̐U蕪																#
	if($access{schedule})
	{
		dbmopen(%SCHEDULE,"$dir{database}/$data{schedule}",undef);
		while(my($key,$value) = each %SCHEDULE)
		{
			@field{'begin','finish','bweek','fweek','btime','ftime','loop','key','event','category','text','file'} = split(/\t/,$value);
			next if(!$field{key} or $field{category} !~ /^$cgi{category}/);
			@field{'byear','bmonth','bday'} = split("\/",$field{begin});
			$field{tyear} = $nowyear + ($field{bmonth} == 1);
			$field{todate} = sprintf("%04s/%02s/%02s",$field{tyear},$field{bmonth},$field{bday});
			$loop = $event{$field{loop}}+$field{loop};
			#=======================================================================#
			#	Jni݂傫jA								#
			#		ÑCxgŊJnߋŁAIŁA1ȓ	#
			if
			(
				($nowdate lt $field{begin})	#
				or
				($loop == 4 and $field{begin} le $nowdate and $field{finish} ge $nowdate and $field{todate} lt $nextdate and $field{todate} ge $nowdate)
			)
			{
				unshift(@future,$value)		#\ɒǉ
			}
			elsif
			(
				(
					$loop < 2 or 6 < $loop
					or
					($loop == 2 and $field{bweek} eq $nowweek)
					or
					($loop == 3 and ($field{bday} le $nowday and $nowday le $field{fday}))
					or
					($loop == 4 and ("$field{bmonth}/$field{bday}" le "$month/$day" and "$month/$day" le "$field{fmonth}/$field{fday}"))
					or
					($loop == 5 and $nowweek ne "")
					or
					($loop == 6 and $nowweek ne "" and $nowweek ne "y")
				)
				and
				($field{begin} le $nowdate and $nowdate le $field{finish})
			)
			{
				push(@today,$value);		#ɒǉ
			}
			#=======================================================================#
			#	NȊÕCxgŊJnߋi݂菬jŁA				#
			#		Ii݂傫j									#
			elsif
			(
				($field{begin} le $nowdate and $nowdate le $field{finish} and $loop != 4)
			)
			{
				push(@present,$value);		#Őisɒǉ
			}
			#=======================================================================#
			#	Jnߋ̏TEENzi߂Cxg̓qXg[j	#
			elsif
			(
				($field{begin} le $nowdate and $loop >= 7)
			)
			{
				push(@lately,$value);		#Jnςݐisɒǉ
			}
			#=======================================================================#
			#	1TԂ̃Cxgɒǉ		#
			unless
			(
				($field{begin} lt $headdate and $field{finish} le $headdate)
				or
				($field{begin} gt $hipdate and $field{finish} ge $hipdate)
			)
			{
				push(@subject,$value);
			}
		}
		dbmclose(%SCHEDULE);
	}
	#-------------------------------------------------------------------------------------------#
	#	todayEBhEIɊJ															#
	if($access{today})
	{
		print qq|<script type="text/javascript" charset="Shift_JIS">\n|;
		print qq|<!--//\n|;
		print qq|if(GetCookie("open") == "true")\n|;
		print qq|{\n|;
		print qq|	if(GetCookie("today") != "today")\n|;
		print qq|	{\n|;
		print qq|		now=new Date();\n|;
		print qq|		year='0'+now.getFullYear();\n|;
		print qq|		month=now.getMonth()+1;\n|;
		print qq|		month='0'+month;\n|;
		print qq|		day='0'+now.getDate();\n|;
		print qq|		calender='$script{today}?date='+year.substr(year.length-4,4)+'/'+month.substr(month.length-2,2)+'/'+day.substr(day.length-2,2);\n|;
		print qq|		todayopen(calender);\n|;
		print qq|	}\n|;
		print qq|}\n|;
		print qq|//-->\n|;
		print qq|</script>\n|;
	}
	#=======================================================================#
	#	IvVRec												#
	&print_weeklycalender($nowdate,@subject)	if($access{calender});
	if($access{schedule})
	{
		&print_future(@future);
		&print_today(@today);
		&print_present(@present);
		&print_lately(@lately);
	}
}
#####################################################################################################

#####################################################################################################
sub print_introduction
{
	if($access{news} and $access{graffiti})
	{
		print qq|<div id="sectionA">\n|;
		&print_news ;
		print qq|</div>\n|;
		print qq|<hr>\n|;
		print qq|<div id="sectionB">\n|;
		&print_graffiti;
		print qq|</div>\n|;
	}
	elsif($access{news})
	{
		&print_news ;
	}
	elsif($access{graffiti})
	{
		&print_graffiti;
	}
	if($access{message})
	{
		print qq|<hr>\n|;
		&print_message;
	}
	if($access{forum})
	{
		print qq|<hr>\n|;
		&print_forum;
	}
	if($access{booklet})
	{
		print qq|<hr>\n|;
		&print_booklet;
	}
}
#####################################################################################################

#####################################################################################################
sub print_news
{
	#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++#
	#	j[X̕\													#
	my($i);
	my(%old);
	dbmopen(%NEWS,"$dir{database}/$data{news}",undef);
	print qq|<div class="block news">\n|;
	print qq|<h3><a href="$script{news}">|.&title('news_menu').qq|</a></h3>\n|;
	print qq|<div class="list">\n|;
	foreach(sort {$b cmp $a} values %NEWS)
	{
		@field{'timestump','category','title','text','file','page','userid'} = split(/\t/,$_);
		next unless($field{category} =~ /^$cgi{category}/ or $field{category} == 0);
		@field{'year','month','day','x','x','x','week'}=&get_date($field{timestump});
		#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++#
		#	t̕\														#
		if($old{year} ne $field{year} or $old{month} ne $field{month} or $old{day} ne $field{day})
		{
			print qq|</div>\n|	if($old{year});
			print qq|<div class="day">\n<h4 class="date">\n|;
			printf("%4sN",$field{year}) if($old{year} != $field{year});
			printf("%2s",$field{month}) if($old{year} != $field{year} or $old{month} != $field{month});
			printf("%2s",$field{day}) if($old{year} != $field{year} or $old{month} != $field{month} or $old{day} != $field{day});
			print qq|i$field{week}j|;
			print qq|\n</h4><!--date-->\n|;
		}
		#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++#
			my($text) = &get_text($field{text});
#			$text =~ s~^(.{64,256}\s).*~$1<a href="$script{news}?exec=detail&amp;timestump=$field{timestump}">ǂ</a>~sx
#						if(length($text) > 256);
			print qq|<div class="item">\n|;
			print qq|<h5>\n|;
			&print_news_subject(@field{'timestump','category','title','page'});
			print qq|</h5>\n|;
			print qq|<div class="content">\n|;
			print &print_text($text);
			print qq|</div>\n|;
			print qq|</div>\n|;
		#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++#

		last if(++$i>=$lines);
		$old{year}	= $field{year};
		$old{month}	= $field{month};
		$old{day}	= $field{day};
	}
	print qq|</div>\n| if($old{year});
	print qq|</div><!--list-->\n|;
	print qq|</div><!--news-->\n|;
	dbmclose(%NEWS);
	#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++#
}
#####################################################################################################
sub print_news_subject
{
	my($timestump,$category,$title,$page) = @_;
	print qq|<a href="$script{news}?exec=detail&amp;timestump=$timestump" title="|.	&title('news_item').qq|:$title($CATEGORY{$category})">|;
	&print_category_icon($category,'[N]');
	print qq|$field{title}</a>\n|;
	&print_reference_link($page);
}
#####################################################################################################
sub print_graffiti
{
	#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++#
	#	̕\													#
	my($i);
	dbmopen(%GRAFFITI,"$dir{database}/$data{graffiti}",undef);
	dbmopen(%FILE,"$dir{database}/$data{file}",undef);
	print qq|<div class="block graffiti">\n|;
	print qq|<h3><a href="$script{graffiti}">|.&title('graffiti_menu').qq|</a></h3>\n|;
	@field{'number','title','text','file','name','date','ip','contact','canvas'} = split(/\t/,$GRAFFITI{sprintf("%05d",$GRAFFITI{num})});
	print qq|<div class="item">\n|;
	print qq|<div class="date">XVF$field{date}</div>\n|;
	if($FILE{$field{file}})
	{
		&print_file($field{file});
	}
	print qq|</div>\n|;
	print qq|<!--dummy-->\n</div>\n<!--graffiti-->\n|;#graffiti
	dbmclose(%FILE);
	dbmclose(%GRAFFITI);
	#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++#
}
#####################################################################################################

#####################################################################################################
sub print_booklet
{
	my(@lastvisit) = split(/<>/,$cookie{visit_booklet});
	my($year,$month,$day,$hour,$minute) = &get_date(time-60*60*24);		#	Ԃ擾ϐɊi[iO[oj
	my($yesterday) = "$year\/$month\/$day\ $hour\:$minute";				#	e
	my($year,$month,$day,$hour,$minute) = &get_date(time-60*60*24*7);	#	Ԃ擾ϐɊi[iO[oj
	my($lastweek) = "$year\/$month\/$day\ $hour\:$minute";				#	e

	print qq|<div class="block booklet">\n|;
	print qq|<h3><a href="$script{booklet}">|.&title('booklet_menu').qq|</a></h3>\n|;
	dbmopen(%DIVISION,"$dir{database}/$data{booklet}",undef);
	print qq|<div class="list">\n|;
	print qq|<table frame="border" border="1" summary="Updated booklet">\n|;
	foreach(sort values %DIVISION)
	{
		@field{'category','division','thema','auth','comment','threads','lastthread','thread','date'} = split(/\t/,$_);
		next if(!$field{thema} or $field{category} !~ /^$cgi{category}/);
		if((~($field{auth}+0) & $permission) & 0xAA)
		{
			my($img)="";

			if((~($field{auth}+0) & $permission) & 0x55)		{	$img .= qq|open_|;	}
			if($field{date} gt $lastvisit[$field{division}])	{	$img .= qq|never_|;	}
			if($field{date} gt $yesterday)						{	$img .= qq|day|;	}
			elsif($field{date} gt $lastweek)					{	$img .= qq|week|;	}
			else												{	$img .= qq|old|;	}

			print qq|<tr>\n|;
			print qq|<td class="category">\n|;
			if($field{category} ne $old{category})
			{
				print qq|<a href="$script{booklet}?category=$field{category}" title="|.&title('booklet_item').qq|:$CATEGORY{$field{category}}">|;
				&print_category_icon($field{category},'[B]');
				print qq|</a>\n|;
			}
			print qq|</td>\n|;
			print qq|<td class="subject">\n|;
			print qq|<a href="$script{booklet}?exec=division&amp;division=$field{division}" title="|.
						&title('booklet_item').qq|:$field{thema}($CATEGORY{$field{category}})">|;
			print qq|<img src="$url{images}/forum_$img.gif" alt="[*]" title="$img" width="16" height="16">|;
			print qq|$field{thema}|;
			print qq|</a>\n|;
			print qq|</td>\n|;
			print qq|<td class="comment">$field{comment}</td>\n|;
			print qq|</tr>\n|;
			$old{category} = $field{category};
		}
	}
	print qq|</table>\n</div><!--list-->\n|;
	dbmclose(%DIVISION);
	print qq|</div>\n|;
}
#####################################################################################################

#####################################################################################################
sub print_forum
{
	my(@lastvisit) = split(/<>/,$cookie{visit_forum});
	my($year,$month,$day,$hour,$minute) = &get_date(time-60*60*24);		#	Ԃ擾ϐɊi[iO[oj
	my($yesterday) = "$year\/$month\/$day\ $hour\:$minute";				#	e
	my($year,$month,$day,$hour,$minute) = &get_date(time-60*60*24*7);	#	Ԃ擾ϐɊi[iO[oj
	my($lastweek) = "$year\/$month\/$day\ $hour\:$minute";				#	e

	print qq|<div class="block forum">\n|;
	print qq|<h3><a href="$script{forum}">|.&title('forum_menu').qq|</a></h3>\n|;
	dbmopen(%FORUM,"$dir{database}/$data{forum}",undef);
	print qq|<div class="list">\n|;
	print qq|<table frame="border" border="1" summary="Updated forum">\n|;
	print	qq|<tr><th class="category"></th>|.
			qq|<th class="subject">tH[(Xbh)</th>|.
			qq|<th class="more">ŏIXVXbh</th>|.
			qq|<th class="date">ŏIe</th>|.
			qq|</tr>\n|;
	foreach(sort values %FORUM)
	{
		@field{'category','division','thema','auth','coment','threads','lastthread','thread','date'} = split(/\t/,$_);
		next if(!$field{thema} or $field{category} !~ /^$cgi{category}/);
		if((~($field{auth}+0) & $permission) & 0xAA)
		{
			my($img)="";
			if((~($field{auth}+0) & $permission) & 0x55)		{	$img .= qq|open_|;	}
			if($field{date} gt $lastvisit[$field{division}])	{	$img .= qq|never_|;	}
			if($field{date} gt $yesterday)						{	$img .= qq|day|;	}
			elsif($field{date} gt $lastweek)					{	$img .= qq|week|;	}
			else												{	$img .= qq|old|;	}
			print qq|<tr>\n|;
			print qq|<td class="category">\n|;
			if($field{category} ne $old{category})
			{
				print qq|<a href="$script{forum}?category=$field{category}" title="|.&title('forum_Contents').qq|:$CATEGORY{$field{category}}">|;
				&print_category_icon($field{category},'[R]');
				print qq|</a>\n|;
			}
			print qq|</td>\n|;
			print qq|<td class="subject">\n|;
			print qq|<a href="$script{forum}?exec=division&amp;division=$field{division}" title="|.
						&title('forum_item').qq|:$field{thema}($CATEGORY{$field{category}})">|;
			print qq|<img src="$url{images}/forum_$img.gif" alt="[]" title="$img" width="16" height="16">|;
			print qq|$field{thema}|;
			print qq|</a>($field{threads})\n|;
			print qq|</td>\n|;
			$field{thread} =~ s/^(.{0,24}(?![\x81-\x9f][\x40-\xfc]|[\xe0-\xfc][\x40-\xfc]).?)?.*/$1.../x;
			print qq|<td class="more">\n|;
			print qq|<a href="$script{forum}?exec=tree&amp;division=$field{division}&amp;thread=$field{lastthread}" title="|.
						&title('forum_item').qq|:$field{thema}($CATEGORY{$field{category}})/$field{thread}">$field{thread}</a>\n|;
			print qq|</td>\n|;
			print qq|<td class="date">$field{date}</td>\n|;
			print qq|</tr>\n|;
			$old{category} = $field{category};
		}
	}
	print qq|</table>\n</div><!--list-->\n|;
	dbmclose(%FORUM);
	print qq|</div><!--forum-->\n|;
}
#####################################################################################################

#####################################################################################################
sub print_message
{
	my($page,$serials,@serial);
	undef($i);
	print qq|<div class="block message">\n|;
	print qq|<h3><a href="$script{message}">|.&title('message_menu').qq|</a></h3>\n|;
	print qq|<div class="list">\n|;
	print qq|<table frame="border" border="1" summary="New Message">\n|;
	print qq|<tr><th class="subject">gsbN(e)</th><th class="name">ŏIe</th><th class="date">ŏIe</th></tr>\n|;
	open(MESSAGE,"$dir{database}/$data{message}.$ext");
	while($i < $lines)
	{
		last if(eof(MESSAGE));
		$page = <MESSAGE>;
		chomp($page);#Iɍ폜
		@field{'page','category','topic','awner','serials','name','update','sendto'} = split(/\t/,$page);
		next if($field{sendto} and $cookie{id} ne $field{awner} and $cookie{id} ne $field{sendto});
		next if($field{category} !~ /^$cgi{category}/);
		$serials = @serial = split(",",$field{serials});
		print qq|<tr>\n|;
		print qq|<td class="subject">\n|;
		print qq|<a href="$script{message}?exec=reply&amp;page=$field{page}&amp;serial=$serial[0]" title="|.
					&title('message_item').qq|:$field{topic}($CATEGORY{$field{category}})">|;
		&print_category_icon($field{category},'[M]');
		print qq|$field{topic}</a>($serials)\n|;
		print qq|</td>\n|;
		print qq|<td class="name">$field{name}</TD>\n|;
		print qq|<td class="date">$field{update}</td>\n|;
		print qq|</tr>\n|;
		++$i;
	}
	print qq|</table>\n</div><!--list-->\n|;
	close(MESSAGE);
	print qq|</div><!--message-->\n|;
}
#####################################################################################################

#####################################################################################################
sub print_events_sub
{
	my($type,@event) = @_;
	undef(%old);
	print qq|<div class="block $type">\n|;
	print qq|<h3>|.&title($type).qq|</h3>\n|;
	print qq|<ul class="list">\n|;
	foreach(sort {$a cmp $b} @event)		{	&print_event($_);	}
	print qq|</ul>\n| if($old{begin});
	print qq|</ul><!--list-->\n|;
	print qq|</div>\n|;
}
#####################################################################################################

#####################################################################################################
sub print_future
{
	&print_events_sub('future',@_) if(@_);
}
#####################################################################################################

#####################################################################################################
sub print_today
{
	&print_events_sub('today',reverse(@_)) if(@_);
}
#####################################################################################################

#####################################################################################################
sub print_present
{
	&print_events_sub('present',reverse(@_)) if(@_);
}
#####################################################################################################

#####################################################################################################
sub print_lately
{
	&print_events_sub('lately',reverse(@_)) if(@_);
}
#####################################################################################################

#####################################################################################################
sub print_weeklycalender
{
	my($nowdate,@subject) = @_;
	#-------------------------------------------------------------------------------------------#
	#	TԃJ_[̕\																	#
	if($access{diary})	{	dbmopen(%DIARY,"$dir{database}/$data{diary}",undef);	}
	print qq|<div class="block calender week">\n|;
	print qq|<h3><a href="$script{calender}">|.&title('calender_menu').qq|</a></h3>\n|;
	print qq|<table frame="border" border="1" summary="weekly calender">\n|;
	for($i=-3;$i<=3;$i++)
	{
		my($year,$month,$day,$x,$x,$x,$week) = &get_date(time+$i*24*60*60);
		my($date)="$year/$month/$day";
		print qq|<tr|;
		if		($week eq '')	{	print qq| class="sunday|;	}
		elsif	($week eq 'y')	{	print qq| class="saturday|;	}
		else					{	print qq| class="weekday|;	}
		if		($i == 0)		{	print qq| today|;			}
		print qq|">\n|;
		#<<<<<<<<<<	t
		print qq|<td class="date">\n|;
		if($access{today})
		{
			print qq|<a |.&WHOpPERL::jslink('todayopen',qq|$script{today}?date=$year\/$month\/$day|).qq| title="|.&title('today_item').qq|:$yearN$month$day">\n|;
			print qq|$year/| if($year ne $old{year});
			print qq|$month/| if($month ne $old{month});
			print qq|$dayi$weekj\n|;
			print qq|</a>\n|;
		}
		else
		{
			print qq|$year/| if($year ne $old{year});
			print qq|$month/| if($month ne $old{month});
			print qq|$dayi$weekj\n|;
		}
		print qq|</td><!--date-->\n|;
		print qq|<td>\n|;
		#<<<<<<<<<<	L
		if($DIARY{"$date"} and ($date lt $nowdate or $access{diary} & 0x140))
		{
			print qq|<a href="$script{diary}?exec=detail&amp;date=$date" title="|.&title('diary_item').qq|:$month$day">|;
			print qq|<img src="$url{images}/diary.gif" alt="L" width="16" height="16">|;
			print qq|</a>\n|;
		}
		#<<<<<<<<<<	L̎M
		if($access{diary} & 0x140 and !$DIARY{"$date"} and $date le $nowdate)
		{
			print qq|<span class="exec">\n|;
			print qq|<a href="$script{diary}?exec=new&amp;date=$date" title="|.&title('diary_new').qq|:$month$day">|.&title('diary_new').qq|</a>\n|;
			print qq|</span><!--exec-->\n|;
		}
		print qq|</td>\n|;
		#<<<<<<<<<<	Cxg
		print qq|<td>\n|;
		foreach(@subject)
		{
			@field{'begin','finish','bweek','fweek','btime','ftime','loop','key','event','category','text','file'} = split(/\t/,$_);
			next unless $field{key};
			@field{'byear','bmonth','bday'} = split("\/",$field{begin});
			@field{'fyear','fmonth','fday'} = split("\/",$field{finish});
			$loop = $event{$field{loop}}+$field{loop};

			if
			(
				(
					$loop < 2 or $loop > 6
					or
					($loop == 2 and $field{bweek} eq $week)
					or
					($loop == 3 and ($field{bday} le $day and $field{fday} ge $day))
					or
					($loop == 4 and ("$field{bmonth}/$field{bday}" le "$month/$day" and "$field{fmonth}/$field{fday}" ge "$month/$day"))
					or
					($loop == 5 and $week ne "")
					or
					($loop == 6 and $week ne "" and $week ne "y")
				)
				and
				($field{begin} le $date and $field{finish} ge $date)
			)
			{
				print qq|<a href="$script{schedule}?exec=detail&amp;key=$field{key}" title="|.&title('schedule_item').qq|:$field{event}($CATEGORY{$field{category}})">|;
				print qq|<img src="$url{category}/category$field{category}.gif" alt="[E]" width="16" height="16">|;
				print qq|</a>\n|;
			}
		}
		print qq|</td>\n|;
		$old{year}	= $year;
		$old{month}	= $month;
		print qq|</tr>\n|;
	}
	print qq|</table><!--week-->\n|;
	print qq|</div>\n|;
	if($access{diary})	{	dbmclose(%DIARY);	}
	#-------------------------------------------------------------------------------------------#
}
#####################################################################################################
sub MainMenu_submenu{}
#####################################################################################################
#----------	Cxg̏o																			#
sub print_event
{
	my(%field,$subject);
	@field{'begin','finish','bweek','fweek','btime','ftime','loop','key','event','category','text','file','page'} = split(/\t/,$_[0]);
	@field{'byear','bmonth','bday'} = split("\/",$field{begin});
	@field{'fyear','fmonth','fday'} = split("\/",$field{finish});
	$loop = $event{$field{loop}}+$field{loop};

	#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
	#<<<<<<<<<<	̏o																			#
	if($old{begin} ne $field{begin} or $old{finish} ne $field{finish} or $old{btime} ne $field{btime} or $old{ftime} ne $field{ftime} or $old{loop} ne $field{loop})
	{
		print qq|</ul>\n</li>\n|	if($old{begin});
		print qq|<li>\n<div class="date">\n|;
		print qq|<span class="date">|;
		#-------------------------------------------------------------------------------------------#
		#	Jn̕\																			#
		print $field{byear} 		if(                      $old{byear} ne $field{byear});
		print qq|/|					if(                      $old{byear} ne $field{byear} and $loop != 4);
		print $field{bmonth}		if(($oldloop != $loop or $old{byear} ne $field{byear} or $old{bmonth} ne $field{bmonth}) and $loop != 4);
		print qq|/|					if(($oldloop != $loop or $old{byear} ne $field{byear} or $old{bmonth} ne $field{bmonth}) and ($loop != 3 and $loop != 4));
		print $field{bday}			if(($oldloop != $loop or $old{byear} ne $field{byear} or $old{bmonth} ne $field{bmonth} or $old{bday} ne $field{bday}) and ($loop != 3 and $loop != 4));
		print qq|($field{bweek})|	if(($oldloop != $loop or $old{begin} ne $field{begin}) and $loop < 2);
		print $field{btime}			if($field{btime} ne '==:==' and $loop == 0);
		#-------------------------------------------------------------------------------------------#
		#	I̕\																			#
		if($field{begin} ne $field{finish} or ($field{btime} ne $field{ftime} and $loop == 0))
		{
			print '`'					if(($field{byear} ne $field{fyear}) or ($field{bmonth} ne $field{fmonth} and $loop < 4) or ($field{begin} ne $field{finish} and ($loop != 4)) or ($field{btime} ne $field{ftime} and $loop == 0));
			if($field{fyear} ne '====' or $field{fmonth} ne '==' or $field{fday} ne '==')
			{
				if($field{fyear} ne '====' or $field{fmonth} ne '==' or $loop != 3)
				{
					print $field{fyear}			if( $field{byear} ne $field{fyear} and ($field{fyear} ne '====' or $loop != 4));
					print qq|/|					if( $field{byear} ne $field{fyear} and $loop != 4);
					print $field{fmonth}		if(($field{byear} ne $field{fyear} or $field{bmonth} ne $field{fmonth}) and $loop != 4);
				}
				print qq|/|					if(($field{byear} ne $field{fyear} or $field{bmonth} ne $field{fmonth}) and ($loop != 3 and $loop != 4));
				print $field{fday}			if(($field{begin} ne $field{finish}) and ($loop != 3 and $loop != 4));
				print qq|($field{fweek})|	if( $field{begin} ne $field{finish} and $loop < 2);
				print $field{ftime}			if($field{btime} ne $field{ftime} and $loop == 0);
			}
		}
		print qq|</span>\n|;
		#-------------------------------------------------------------------------------------------#
		#																							#
		print qq|<span class="loop">|;
		print (($event{$field{loop}} ne '') ? $field{loop} : $loop[$field{loop}]);
		print qq|($field{bweek})|	 if($loop == 2);
		print qq|$field{bmonth}/|	if($loop == 4);
		print $field{bday}			if($loop == 3 or $loop == 4);
		print '`'					if(($field{bmonth} ne $field{fmonth} and $loop == 4) or ($field{bday} ne $field{fday} and ($loop == 3 or $loop == 4)));
		print qq|$field{fmonth}/|	if( $field{bmonth} ne $field{fmonth} and $loop == 4);
		print $field{fday}			if(($field{bmonth} ne $field{fmonth} and $loop == 4) or ($field{bday} ne $field{fday} and ($loop == 3 or $loop == 4)));
		print qq|</span>\n|;
		if($loop != 0 and $field{btime} ne '==:==')
		{
			print qq|<span class="time">$field{btime}|;
			print qq|`$field{ftime}|			if($field{btime} ne $field{ftime});
			print qq|</span>\n|;
		}
		print qq|</div><!--date-->\n|;
		print qq|\n<ul>\n|;
	}
	#_______________________________________________________________________________________________#

	#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
	#<<<<<<<<<<	TuWFNg̏o																	#
	print qq|<li class="subject">\n|;
	#-------------------------------------------------------------------------------------------#
	#	JeS[ACȐo																#
	print qq|<a href="$script{schedule}?exec=detail&amp;key=$field{key}" title="|.
				&title('scheudle_item').qq|:$field{event}($CATEGORY{$field{category}})">|;
	&print_category_icon($field{category},'[E]');
	print qq|</a>\n|;
	#-------------------------------------------------------------------------------------------#
	#	Cxg̍ڂ̏o																	#
	foreach(split(" ",$field{event}))
	{
		$subject .= $_;
		@field{'x','x','site','x','url'} = split(/\t/,($SITE{$subject} ? $SITE{$subject} : $SITE{$_}));
		if($field{url})	{	print qq|<a href="$field{url}" title="|.&title('site_item').qq|:$subject">$_</A> |;	}
		else			{	print qq|$_ |;		}
		$subject .= " ";
	}
	&print_reference_link($field{page});
	#-------------------------------------------------------------------------------------------#
	print qq|\n</li><!--subject-->\n|;
	#_______________________________________________________________________________________________#

	#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
	#<<<<<<<<<<																						#
	%old = %field;
	$oldloop = $loop;
	#_______________________________________________________________________________________________#
}
#####################################################################################################

#####################################################################################################
#----------	^XNf[^̏																		#
#	index	task	today																			#
sub doit
{
	my(%field);
	@field{'limit','key','task','category','text','file','user','check'} = split(/\t/,@_[0]);
	if(($cookie{id} and $field{user} eq $cookie{id}) or $access{task} & 0x140)
	{
		$field{check} = ($field{check} ? '' : 1);
	}
	return("$field{limit}\t$field{key}\t$field{task}\t$field{category}\t$field{text}\t$field{file}\t$field{user}\t$field{check}");
}
#####################################################################################################
return('main');
