#####################################################################################################
#	database::
sub set_Main
{
	my(%exec) = @_;

	if($access{$cginame} & 0x3ff)
	{
		$exec{$cgi{exec}} ? &{$cgi{exec}} : &main;
	}
	else
	{
		$Main = 'print_permission';
	}
}
#####################################################################################################

#####################################################################################################
#	
sub save_text
{
	my($filename,$text) = @_;
	unlink("$dir{text}/$filename") if(-f "$dir{text}/$filename");
	if($text)
	{
		open(TEXT,">$dir{text}/$filename");
		print TEXT $text;
		close(TEXT);
		chmod($db_permission,"$dir{text}/$filename");
	}
}
#####################################################################################################

#####################################################################################################
#@table::post::
sub delete_sub
{
	my($DATA,$keyname,$key) = @_;
	my(%field);

	$who->lock;

	@field{@fieldname} = split(/\t/,$DATA->{$key});
	unless($field{$keyname})
	{
		$who->push_error('w肳ꂽACe܂B');
	}
	elsif(($field{userid} and $cookie{id} eq $field{userid} and $access{$cginame} & 0x55) or $access{$cginame} & 0x140)
	{
		delete($DATA->{$key});
		unlink("$dir{text}/$field{filename_text}") if(-f "$dir{text}/$field{filename_text}");
		$who->push_complete("Key[$key]̃f[^̍폜܂B");
#		$cgiurl = "$script{$cginame}?exec=new";
	}
	else
	{
		$who->push_error('폜܂B');
	}

	$who->unlock;
}
#####################################################################################################

#####################################################################################################
#	Main
#####################################################################################################
#	miniboard::
sub Detail
{
	print	qq|<div id="Detail" class="contents">\n|;
	print	qq|<h3><a href="#Detail">|.&title("$cginame\_item").&title('Detail').qq|</a></h3>\n|;
	&print_item(@_);
	print	qq|</div>\n|;
}
#####################################################################################################

#####################################################################################################
#	miniborad::
sub Contents
{
#	my($from)	= $cgi{from} + 1;
	print		qq|<div id="Contents" class="contents">\n|;
	&Contents_head;
#	printf(qq|<h3><a href="#Contents">No.%02d - No.%02d / %02d hits</a></h3>\n|,$from,$next,$hit);
	&Contents_sub;
	print		qq|</div>\n|;
}
#	database::
sub Contents_sub
{
	my($hit,$prev,$next,@hit) = @_;
	my($link)	= &get_link;
	foreach(@hit)
	{
		print	qq|<hr>\n|;
		&print_item($_);
	}
}
#####################################################################################################

#####################################################################################################
#	database::
sub Index
{
	my($hit,$prev,$next,@hit) = @_;
	my($from)	= $cgi{from} + 1;
	my($link)	= &get_link;

	print		qq|<div id="Index" class="index">\n|;

	print		qq|<table class="list" frame="border" border="1" summary="$cginame Index">|;
	printf		(qq|<caption><a href="#Index">No.%02d - No.%02d / %02d hits</a></caption>\n|,$from,$next,$hit);
	&Index_head;
	foreach(@hit)
	{
		&print_each($_);
	}
	print		qq|</table>\n|;

	print		qq|</div>\n|;
}
#####################################################################################################
#	Navigation
#####################################################################################################
#	database::
sub PageNavi
{
	my($hit)	= @_;
	my($from)	= ($cgi{from} - $lines * 5) < 0 ? 0 : ($cgi{from} - $lines * 5);
	my($to)		= $hit < ($cgi{from} + $lines * 5) ? $hit : ($cgi{from} + $lines * 5);
	my($i,$j);
	my($link)		= &get_link;
#	print		qq|<fieldset id="PageNavi" class="navigation">\n|;
#	print		qq|<legend><a href="#PageNavi">|.&title('PageNavi').qq|</a></legend>\n|;
	print		qq|<fieldset class="navigation">\n|;
	print		qq|<legend>|.&title('PageNavi').qq|</legend>\n|;
	print		qq|<ul class="link">\n|;
	print		qq|<li><a href="$script{$cginame}?from=0$link">|.&title('first').qq|</a></li>\n| if(0 < $from);
	print		qq|<li><a href="$script{$cginame}?from=$prev$link">|.&title('prev').qq|</a></li>\n| if($prev < $cgi{from});
	for($i = $from;$i <= $to;$i += $lines)
	{
		$j = $i / $lines + 1;
		if($i == $cgi{from})
		{
			printf(qq|<li><a>%03d</a></li>\n|,$j);
		}
		else
		{
			print qq|<li><a href="$script{$cginame}?from=$i$link">|.sprintf(qq|%03d</a></li>\n|,$j);
		}
	}
	print		qq|<li><a href="$script{$cginame}?from=$next$link">|.&title('next').qq|</a></li>\n| if($next < $hit);
	print		qq|<li><a href="$script{$cginame}?from=$last$link">|.&title('last').qq|</a></li>\n| if($to < $last);
	print		qq|</ul>\n|;
	print		qq|</fieldset>\n|;
}
#####################################################################################################
#	Form
#####################################################################################################
#	database::
sub NewForm
{
	print	qq|<fieldset id="NewForm" class="postform">\n|;
	print	qq|<legend><a href="#NewForm">|.&title("$cginame\_NewForm").qq|</a></legend>\n|;
	&print_post(@_);
	print	qq|</fieldset>\n|;
}
#####################################################################################################

#####################################################################################################
#	database::
sub CorrectForm
{
	print	qq|<fieldset id="CorrectForm" class="postform">\n|;
	print	qq|<legend><a href="#CorrectForm">|.&title("$cginame\_item").&title('CorrectForm').qq|</a></legend>\n|;
	&print_post(@_);
	print	qq|</fieldset>\n|;
}
#####################################################################################################

#####################################################################################################
#	database::
sub DeleteForm
{
	my($key,$value) = @_;
	print	qq|<fieldset id="DeleteForm" class="deleteform">\n|;
	print	qq|<legend><a href="#DeleteForm">|.&title("$cginame\_item").&title('DeleteForm').qq|</a></legend>\n|;
	print	qq|<form method="post" action="$script{$cginame}">\n|;
	print	qq|<div class="form">\n|;
	print	qq|<input type="checkbox" name="$key" value="$value">\n|;
	print	qq|<input type="hidden" name="exec" value="delete">\n|;
	print	qq|<input type="submit" value="|.&title('delete').qq|">\n|;
	print	qq|</div>\n|;
	print	qq|</form>\n|;
	print	qq|</fieldset>\n|;
}
#####################################################################################################

#####################################################################################################
#	borad::
sub print_item_userid
{
	my(%field);
	@field{'name','mail'} = @_;
	@field{'userid','category','filename_text','filenumber','password','character'}	= split(/\t/,$PEAPLE{$field{name}});
	@field{'character','icon'} = split(/\t/,$CHARACTER{$field{character}});
	my($userid) = &WHOpPERL::encode($field{name});

	print qq|<div class="awner">\n|;
	print qq|<div class="name">\n|;
	if($field{category})
	{
		print	qq|<a href="$script{peaple}?exec=detail&amp;userid=$userid" title="|.
						&title('peaple_item').qq|:$field{userid}($CATEGORY{$field{category}})">|;
		&print_category_icon($field{category},'[P]');
		print	qq|$field{userid}</a>\n|;
	}
	elsif($field{name} eq $cookie{name})	{	print qq|<a href="$script{peaple}?exec=new&amp;userid=$userid" title="|.
												&title('peaple_new').qq|:$field{name}">$field{name}</a>\n|;	}
	elsif($field{mail})				{	print qq|<a href="mailto:$field{mail}">$field{name}</a>\n|;	}
	else							{	print qq|$field{name}\n|;	}
	print qq|</div><!--name-->\n|;
	if($field{icon})
	{
		print qq|<div class="icon">|;
		print qq|<img src="$url{icons}/$field{icon}" title="$field{character}" alt="(^^)" width="64" height="64">|;
		print qq|</div><!--icon-->\n|;
	}
	print qq|</div><!--awner-->\n|;
}
#####################################################################################################
return(1);
