#local(@atok,@ime);
&imeatok();

#####################################################################################################
sub imeatok
{
	$atok[0]  =	'';			$ime[0]  = ''	;
	$atok[1]  =	'ŗLl';		$ime[1]  = ''	;
	$atok[2]  =	'ŗLl';		$ime[2]  = ''	;
	$atok[3]  =	'ŗLl';		$ime[3]  = 'l'	;
	$atok[4]  =	'ŗLn';		$ime[4]  = 'n̑'	;
	$atok[5]  =	'ŗLgD';		$ime[5]  = 'ŗL'	;
	$atok[6]  =	'ŗLi';		$ime[6]  = 'ŗL'	;
	$atok[7]  =	'ŗL';		$ime[7]  = 'ŗL'	;
	$atok[8]  =	'T';		$ime[8]  = 'ϖ'	;
	$atok[9] =	'U';		$ime[9] = 'ϖ'	;
	$atok[10] =	'`';		$ime[10] = '`'	;
	$atok[11] =	'T`';		$ime[11] = 'ό`'	;
	$atok[12] =	'';		$ime[12] = ''	;
	$atok[13] =	'Ɨ';		$ime[13] = '̑'	;
	$atok[14] =	'Jsܒi';		$ime[14] = 'sܒi'	;
	$atok[15] =	'Ksܒi';		$ime[15] = 'sܒi'	;
	$atok[16] =	'Tsܒi';		$ime[16] = 'sܒi'	;
	$atok[17] =	'^sܒi';		$ime[17] = 'sܒi'	;
	$atok[18] =	'isܒi';		$ime[18] = 'ȍsܒi'	;
	$atok[19] =	'osܒi';		$ime[19] = '΍sܒi'	;
	$atok[20] =	'}sܒi';		$ime[20] = '܍sܒi'	;
	$atok[21] =	'sܒi';		$ime[21] = 'sܒi'	;
	$atok[22] =	'sܒi';		$ime[22] = 'sܒi'	;
	$atok[23] =	'nsli';		$ime[23] = 'sܒi'	;
	$atok[24] =	'i';		$ime[24] = 'i'	;
	$atok[25] =	'`e';		$ime[25] = '`e'	;
	$atok[26] =	'`e';		$ime[26] = '`e'	;
	$atok[27] =	'`^';		$ime[27] = '`e'	;
}                                     
#####################################################################################################

#####################################################################################################
sub relation_check_word
{
	my(@word) = split(/,/,$_[0]);
	my(%more);

	foreach(@_)
	{
		foreach(split(/&amp;|[!&+,-.\/:;=?@\\_\|~]/,$_))
		{
			my($more) = '';
			foreach(split(" ",$_))
			{
				$more .= $_;
				push(@word,$_)				if($WORD{$_});
				push(@word,$more)			if($WORD{$more});
				$more .= " ";
			}
		}
	}

	@word = grep(!$word{$_}++,@word);	#	@word̃j[N
	return(@word);
}
#####################################################################################################

#####################################################################################################
sub RelationWords
{
	my(@word) = &relation_check_word(@_);
	if(@word)
	{
		print qq|<hr>\n|;

	#	print qq|<div id="RelationWords" class="index">\n|;
		print qq|<table id="RelationWords" class="index list" frame="border" border="1">\n|;
		print qq|<caption><a href="#RelationWords">|.&title('Relation').&title('word_item').qq|</a></caption>\n|;
		&Index_head_word;
		foreach(sort {$a cmp $b} @word)
		{
			if($WORD{$_})	{	&print_each_word($WORD{$_});	}
			else
			{
				my($enc) = &WHOpPERL::encode($_);
				print qq|<tr>\n<td class="exec">\n|;
				if		($access{word} & 0x155)	{	print qq|<a href="$script{word}?exec=new&amp;word=$enc" title="|.&title('word_new').qq|:$_">$_</a>\n|;	}
				else							{	print qq|$_ \n|;	}
				print qq|<td class="coment">o^łB</td>\n|;
				print qq|</td>\n</tr>\n|;
			}
		}
		print qq|</table>\n|;
	#	print qq|</div>\n|;
	}
}
#####################################################################################################

#####################################################################################################
sub Index_head_word
{
	print qq|<tr>\n|;
	print qq|<th class="subject">|.&title('word_item').qq|</th>\n|;
	print qq|<th class="comment">Ӗ</th>\n|;
	print qq|<th class="category">i</th>\n|;
#	print qq|<th class="more">֘AP</th>\n|;
	print qq|</tr>\n|;
}
#####################################################################################################

#####################################################################################################
sub print_each_word
{
	my(%field,%enc);
	@field{'sound','word','category','text','file','mean','more','part','page'} = split(/\t/,$_[0]);
	$enc{word} = &WHOpPERL::encode($field{word});

	print qq|<tr>\n|;

	print qq|<td class="subject">|;
	print qq|<a href="$script{word}?exec=detail&word=$enc{word}" title="|.&title('word_item').qq|:$field{word}($CATEGORY{$field{category}})">|;
	&print_category_icon($field{category},'[W]');
	&print_subject_word(split(/\t/,$_[0]));
	print qq|</a>\n|;
	&print_reference_link($field{page});
	print qq|</td>\n|;

	print qq|<td class="comment">\n|;
	print qq|$field{mean}\n|;
	print qq|</td>\n|;

	print qq|<td class="category">\n|;
	print qq|$atok[$field{part}]\n|;
	print qq|</td>\n|;

	print qq|</tr>\n|;
}
#####################################################################################################

#####################################################################################################
sub print_subject_word
{
	my(%field,%enc);
	@field{'sound','word','category','text','file','mean','more','part','page'} = @_;
	print qq|<ruby>|;
	print qq|<rb>$field{word}</rb>|;
	print qq|<rp>(</rp><rt>$field{sound}</rt><rp>)</rp>|;
	print qq|</ruby>|;
	print qq|-|			if($field{part} == 14);
	print qq|-|			if($field{part} == 15);
	print qq|-|			if($field{part} == 16);
	print qq|-|			if($field{part} == 17);
	print qq|-|			if($field{part} == 18);
	print qq|-|			if($field{part} == 19);
	print qq|-|			if($field{part} == 20);
	print qq|-iȂj|	if($field{part} == 21);
	print qq|-|			if($field{part} == 22);
	print qq|-|			if($field{part} == 23);
	print qq|-iȂj|	if($field{part} == 24);
	print qq|-|			if($field{part} == 25);
	print qq|-iȁj|		if($field{part} == 26);
	print qq|-|			if($field{part} == 27);
}
#####################################################################################################
1;